﻿using Microsoft.EntityFrameworkCore;
using Abp.Zero.EntityFrameworkCore;
using MineTec.ProManager.Authorization.Roles;
using MineTec.ProManager.Authorization.Users;
using MineTec.ProManager.MultiTenancy;
using MineTec.ProManager.Entitys;

namespace MineTec.ProManager.EntityFrameworkCore
{
    public class ProManagerDbContext : AbpZeroDbContext<Tenant, Role, User, ProManagerDbContext>
    {
        /* Define a DbSet for each entity of the application */

        public ProManagerDbContext(DbContextOptions<ProManagerDbContext> options)
            : base(options)
        {
        }

        public DbSet<UserInfo> UserInfo { get; set; }

        public DbSet<Entitys.Graphic.FigureNumber.FigureNumber> FigureNumber { get; set; }

        public DbSet<Entitys.Graphic.ProductNumber.ProductNumber> ProductNumber { get; set; }

        public DbSet<Entitys.Graphic.MaterialNumber.MaterialNumber> MaterialNumber { get; set; }

        public DbSet<Entitys.Graphic.GalleryInformation.GalleryInformation> GalleryInformation { get; set; }

        public DbSet<Entitys.Graphic.GalleryFiles.GalleryFiles> GalleryFiles { get; set; }

        public DbSet<Entitys.Graphic.GalleryInformation.ViewGalleryInformation> ViewGalleryInformation { get; set; }


        //protected override void OnModelCreating(ModelBuilder modelBuilder)
        //{
        //    modelBuilder.Ignore<Entitys.Graphic.GalleryInformation.ViewGalleryInformation>();
        //    base.OnModelCreating(modelBuilder);
        //}

    }
}
