﻿using System.Collections.Generic;
using System.Threading.Tasks;
using Abp.Auditing;
using MineTec.ProManager.Sessions.Dto;

namespace MineTec.ProManager.Sessions
{
    public class SessionAppService : ProManagerApplicationServiceBase, ISessionAppService
    {
        [DisableAuditing]
        public async Task<GetCurrentLoginInformationsOutput> GetCurrentLoginInformations()
        {
            var output = new GetCurrentLoginInformationsOutput
            {
                Application = new ApplicationInfoDto
                {
                    Version = ProManagerCoreConsts.Version,
                    ReleaseDate = ProManagerCoreConsts.ReleaseDate,
                    Features = new Dictionary<string, bool>()
                }
            };

            if (AbpSession.TenantId.HasValue)
            {
                output.Tenant = ObjectMapper.Map<TenantLoginInfoDto>(await GetCurrentTenantAsync());
            }

            if (AbpSession.UserId.HasValue)
            {
                output.User = ObjectMapper.Map<UserLoginInfoDto>(await GetCurrentUserAsync());
            }

            return output;
        }
    }
}
